<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>HTTPS and TLS Configuration Rule</title>
</head>
<body>
<p>This rule checks for the presence of proper HTTPS/TLS configuration in methods with 'Rest' in their name within Java code. It ensures that <code>SSLContext</code>, <code>CloseableHttpClient</code>, <code>SSLConnectionSocketFactory</code>, and <code>TrustStrategy</code> are present and correctly used and initialized to ensure secure communication.</p>

<h2>Noncompliant Code Example</h2>
<pre>
package com.example;

import org.apache.http.impl.client.HttpClients;
import org.springframework.web.client.RestTemplate;

public class HttpClientExample {
  public RestTemplate myRestTemplate() {
    HttpClient httpClient = HttpClients.custom()
      .setSSLSocketFactory(SSLConnectionSocketFactory.getDefault()) // Noncompliant
      .build();
    return new RestTemplate(new HttpComponentsClientHttpRequestFactory(httpClient)); // Noncompliant
  }
}
</pre>

<h2>Compliant Solution</h2>
<pre>
package com.example;

import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.conn.ssl.SSLConnectionSocketFactory;
import org.apache.http.impl.client.HttpClients;
import org.springframework.web.client.RestTemplate;
import javax.net.ssl.SSLContext;
import org.apache.http.ssl.TrustStrategy;
import java.security.KeyManagementException;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.security.cert.X509Certificate;

public class HttpClientExample {
  public RestTemplate myRestTemplate() throws NoSuchAlgorithmException, KeyManagementException, KeyStoreException {
    // Compliant
    TrustStrategy acceptingTrustStrategy = (X509Certificate[] chain, String authType) -> true; // Example TrustStrategy

    SSLContext sslContext = org.apache.http.ssl.SSLContexts.custom()
      .loadTrustMaterial(null, acceptingTrustStrategy)
      .build();
    SSLConnectionSocketFactory csf = new SSLConnectionSocketFactory(sslContext);

    CloseableHttpClient httpClient = HttpClients.custom()
      .setSSLSocketFactory(csf) // Compliant
      .build();

    return new RestTemplate(new HttpComponentsClientHttpRequestFactory(httpClient)); // Compliant
  }
}
</pre>
</body>
</html>
